Completely rework documentation build
g0dil [Mon, 17 Aug 2009 16:18:57 +0000 (16:18 +0000)]
git-svn-id: https://svn.berlios.de/svnroot/repos/senf/trunk@1294 270642c3-0616-0410-b53a-bc976706d245

23 files changed:
Doxyfile
Examples/RateStuffer/Doxyfile
Examples/Sniffer/Doxyfile
Examples/UDPClientServer/Doxyfile
HowTos/NewPacket/Doxyfile
PPI/Doxyfile
Packets/Doxyfile
SConstruct
Scheduler/Doxyfile
Socket/Doxyfile
Utils/Console/Doxyfile
Utils/Daemon/Doxyfile
Utils/Doxyfile
Utils/Logger/Doxyfile
Utils/Termlib/Doxyfile
doclib/Doxyfile.global
doclib/SConscript
doclib/doxygen.sh [new file with mode: 0755]
doclib/pkgdraw
doclib/tag-munge.xsl [moved from senfscons/tagmunge.xsl with 100% similarity]
senfscons/Doxyfile
senfscons/Doxygen.py
senfscons/SENFSCons.py

index 2183692..37de8ed 100644 (file)
--- a/Doxyfile
+++ b/Doxyfile
@@ -5,12 +5,3 @@ INPUT = . doclib
 PROJECT_NAME = Overview
 PROJECT_NUMBER = "(Version $(REVISION))"
 GENERATE_XML = NO
-GENERATE_TAGFILE = doc/overview.tag
-
-TAGFILES = \
-    "$(TOPDIR)/PPI/doc/PPI.tag" \
-    "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-    "$(TOPDIR)/Packets/doc/Packets.tag" \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag" \
-    "$(TOPDIR)/senfscons/doc/senfscons.tag"
index fb922ad..01dbc0b 100644 (file)
@@ -4,10 +4,3 @@ SHOW_NAMESPACES = NO
 ALPHABETICAL_INDEX = NO
 PROJECT_NAME = RateStuffer
 EXAMPLE_PATH = .
-
-TAGFILES = \
-    "$(TOPDIR)/PPI/doc/PPI.tag" \
-    "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-    "$(TOPDIR)/Packets/doc/Packets.tag" \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag"
index 0387e19..ae04497 100644 (file)
@@ -4,10 +4,3 @@ SHOW_NAMESPACES = NO
 ALPHABETICAL_INDEX = NO
 PROJECT_NAME = Sniffer
 EXAMPLE_PATH = .
-
-TAGFILES = \
-    "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-    "$(TOPDIR)/Packets/doc/Packets.tag" \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag" \
-    "$(TOPDIR)/doc/overview.tag"
index c4ed1e4..df4580b 100644 (file)
@@ -4,10 +4,3 @@ SHOW_NAMESPACES = NO
 ALPHABETICAL_INDEX = NO
 PROJECT_NAME = UDPClientServer
 EXAMPLE_PATH = .
-
-TAGFILES = \
-        "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-        "$(TOPDIR)/Packets/doc/Packets.tag" \
-        "$(TOPDIR)/Socket/doc/Socket.tag" \
-        "$(TOPDIR)/Utils/doc/Utils.tag" \
-        "$(TOPDIR)/doc/overview.tag"
index 30a9e97..4342f32 100644 (file)
@@ -3,10 +3,3 @@
 INPUT = .
 PROJECT_NAME = NewPacket
 EXAMPLE_PATH = .
-
-TAGFILES = \
-    "$(TOPDIR)/PPI/doc/PPI.tag" \
-    "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-    "$(TOPDIR)/Packets/doc/Packets.tag" \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag"
index cf2dd5f..a328aa4 100644 (file)
@@ -1,13 +1,6 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = libPPI
-GENERATE_TAGFILE = doc/PPI.tag
 RECURSIVE = No
 SHOW_DIRECTORIES = Yes
 INPUT = . detail
-
-TAGFILES = \
-    "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-    "$(TOPDIR)/Packets/doc/Packets.tag" \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag"
index cb3d08e..49a267d 100644 (file)
@@ -1,11 +1,6 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = libPackets
-GENERATE_TAGFILE = doc/Packets.tag
 INPUT = .
 RECURSIVE = YES
 EXAMPLE_PATH = . DefaultBundle
-
-TAGFILES = \
-    "$(TOPDIR)/Utils/doc/Utils.tag" \
-    "$(TOPDIR)/Socket/doc/Socket.tag" 
index 96d958a..a18c65e 100644 (file)
@@ -122,8 +122,6 @@ env.Append(
    LIBS = [ 'rt', '$BOOSTREGEXLIB', '$BOOSTIOSTREAMSLIB', '$BOOSTSIGNALSLIB',
             '$BOOSTFSLIB' ],
    TEST_EXTRA_LIBS = [ ],
-   DOXY_XREF_TYPES = [ 'bug', 'fixme', 'todo', 'idea' ],
-   DOXY_HTML_XSL = '#/doclib/html-munge.xsl',
    ENV = { 'TODAY' : str(datetime.date.today()),
            'REVISION' : rev,
            'LOGNAME' : logname, # needed by the debian build scripts
@@ -131,6 +129,7 @@ env.Append(
            'SCONS' : 1,
            'PATH' : os.environ.get('PATH'),
           'TEXINPUTS' : os.environ.get('TEXINPUTS',env.Dir('#/doclib').abspath + ':'),
+           'DOXYGEN' : os.environ.get('DOXYGEN', 'doxygen'),
          },
    LOCAL_CONFIG_FILES = [ '/Doxyfile.local', '/SConfig', '/local_config.hh' ],
    DPKG_IGNORED_FILES = [ '$LOCAL_CONFIG_FILES', '.svn', '/_templates' ],
@@ -139,6 +138,11 @@ env.Append(
    BUILDPACKAGE_COMMAND = "dpkg-buildpackage -us -uc -rfakeroot $DPKG_IGNORED_FILES_OPTS",
    TOP_INCLUDES = [ 'Packets', 'PPI', 'Scheduler', 'Socket', 'Utils', 'Console',
                     'config.hh', 'local_config.hh' ],
+   ALL_TAGFILES = []
+)
+
+env.Replace(
+   DOXYGENCOM = "doclib/doxygen.sh $DOXYOPTS $SOURCE",
 )
 
 def parseLogOption(value):
@@ -189,9 +193,6 @@ SConscript(glob.glob("*/SConscript"))
 SENFSCons.StandardTargets(env)
 SENFSCons.GlobalTargets(env)
 env.Depends( SENFSCons.Doxygen(env), env.Value(rev) )
-SENFSCons.DoxyXRef(env,
-                   HTML_HEADER = '#/doclib/doxy-header.html',
-                   HTML_FOOTER = '#/doclib/doxy-footer.html')
 
 SENFSCons.InstallIncludeFiles(env, [ 'config.hh' ])
 
index bba9b50..8b55f9d 100644 (file)
@@ -1,9 +1,4 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = libScheduler
-GENERATE_TAGFILE = doc/Scheduler.tag
 ALPHABETICAL_INDEX = NO
-
-TAGFILES = \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag"
index 7a91807..9e64dda 100644 (file)
@@ -1,8 +1,5 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = libSocket
-GENERATE_TAGFILE = doc/Socket.tag
 RECURSIVE = Yes
 SHOW_DIRECTORIES = Yes
-
-TAGFILES = "$(TOPDIR)/Utils/doc/Utils.tag"
index 4b9bc91..c76aad6 100644 (file)
@@ -1,12 +1,5 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = libConsole
-GENERATE_TAGFILE = doc/Console.tag
 EXAMPLE_PATH = .
 EXCLUDE = testServer.cc
-
-TAGFILES = \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag" \
-    "$(TOPDIR)/Utils/Logger/doc/Logger.tag"
index d0761ea..f3e5315 100644 (file)
@@ -1,7 +1,4 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = Daemon
-GENERATE_TAGFILE = doc/Daemon.tag
 ALPHABETICAL_INDEX = NO
-
-TAGFILES = "$(TOPDIR)/Utils/doc/Utils.tag"
index 50cf427..9a072e2 100644 (file)
@@ -1,5 +1,4 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = libUtils
-GENERATE_TAGFILE = doc/Utils.tag
 ALPHABETICAL_INDEX = NO
index 7772501..a9dd3f2 100644 (file)
@@ -1,7 +1,4 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = Logger
-GENERATE_TAGFILE = doc/Logger.tag
 ALPHABETICAL_INDEX = NO
-
-TAGFILES = "$(TOPDIR)/Utils/doc/Utils.tag"
\ No newline at end of file
index 77c744b..0c6a51b 100644 (file)
@@ -1,13 +1,6 @@
 @INCLUDE = "$(TOPDIR)/doclib/Doxyfile.global"
 
 PROJECT_NAME = libTermlib
-GENERATE_TAGFILE = doc/Console.tag
 EXAMPLE_PATH = .
 EXCLUDE = telnetServer.cc
 ALPHABETICAL_INDEX = NO
-
-TAGFILES = \
-    "$(TOPDIR)/Socket/doc/Socket.tag" \
-    "$(TOPDIR)/Scheduler/doc/Scheduler.tag" \
-    "$(TOPDIR)/Utils/doc/Utils.tag" \
-    "$(TOPDIR)/Utils/Logger/doc/Logger.tag"
index 00d7577..92360dc 100644 (file)
-# Doxyfile 1.5.5
+# For a full documented example configuration, call 'doxygen -g -'
 
-# This file describes the settings to be used by the documentation system
-# doxygen (www.doxygen.org) for a project
-#
-# All text after a hash (#) is considered a comment and will be ignored
-# The format is:
-#       TAG = value [value, ...]
-# For lists items can also be appended using:
-#       TAG += value [value, ...]
-# Values that contain spaces should be placed between quotes (" ")
-
-#---------------------------------------------------------------------------
-# Project related configuration options
-#---------------------------------------------------------------------------
-
-# This tag specifies the encoding used for all characters in the config file 
-# that follow. The default is UTF-8 which is also the encoding used for all 
-# text before the first occurrence of this tag. Doxygen uses libiconv (or the 
-# iconv built into libc) for the transcoding. See 
-# http://www.gnu.org/software/libiconv for the list of possible encodings.
-
-DOXYFILE_ENCODING      = UTF-8
-
-# The PROJECT_NAME tag is a single word (or a sequence of words surrounded 
-# by quotes) that should identify the project.
-
-##PROJECT_NAME           = 
-
-# The PROJECT_NUMBER tag can be used to enter a project or revision number. 
-# This could be handy for archiving the generated documentation or 
-# if some version control system is used.
-
-##PROJECT_NUMBER         = 
-
-# The OUTPUT_DIRECTORY tag is used to specify the (relative or absolute) 
-# base path where the generated documentation will be put. 
-# If a relative path is entered, it will be relative to the location 
-# where doxygen was started. If left blank the current directory will be used.
-
-OUTPUT_DIRECTORY       = doc
-
-# If the CREATE_SUBDIRS tag is set to YES, then doxygen will create 
-# 4096 sub-directories (in 2 levels) under the output directory of each output 
-# format and will distribute the generated files over these directories. 
-# Enabling this option can be useful when feeding doxygen a huge amount of 
-# source files, where putting all generated files in the same directory would 
-# otherwise cause performance problems for the file system.
-
-CREATE_SUBDIRS         = NO
-
-# The OUTPUT_LANGUAGE tag is used to specify the language in which all 
-# documentation generated by doxygen is written. Doxygen will use this 
-# information to generate all constant output in the proper language. 
-# The default language is English, other supported languages are: 
-# Afrikaans, Arabic, Brazilian, Catalan, Chinese, Chinese-Traditional, 
-# Croatian, Czech, Danish, Dutch, Farsi, Finnish, French, German, Greek, 
-# Hungarian, Italian, Japanese, Japanese-en (Japanese with English messages), 
-# Korean, Korean-en, Lithuanian, Norwegian, Macedonian, Persian, Polish, 
-# Portuguese, Romanian, Russian, Serbian, Slovak, Slovene, Spanish, Swedish, 
-# and Ukrainian.
-
-OUTPUT_LANGUAGE        = English
-
-# If the BRIEF_MEMBER_DESC tag is set to YES (the default) Doxygen will 
-# include brief member descriptions after the members that are listed in 
-# the file and class documentation (similar to JavaDoc). 
-# Set to NO to disable this.
-
-BRIEF_MEMBER_DESC      = YES
-
-# If the REPEAT_BRIEF tag is set to YES (the default) Doxygen will prepend 
-# the brief description of a member or function before the detailed description. 
-# Note: if both HIDE_UNDOC_MEMBERS and BRIEF_MEMBER_DESC are set to NO, the 
-# brief descriptions will be completely suppressed.
-
-REPEAT_BRIEF           = YES
-
-# This tag implements a quasi-intelligent brief description abbreviator 
-# that is used to form the text in various listings. Each string 
-# in this list, if found as the leading text of the brief description, will be 
-# stripped from the text and the result after processing the whole list, is 
-# used as the annotated text. Otherwise, the brief description is used as-is. 
-# If left blank, the following values are used ("$name" is automatically 
-# replaced with the name of the entity): "The $name class" "The $name widget" 
-# "The $name file" "is" "provides" "specifies" "contains" 
-# "represents" "a" "an" "the"
-
-##ABBREVIATE_BRIEF       = 
-
-# If the ALWAYS_DETAILED_SEC and REPEAT_BRIEF tags are both set to YES then 
-# Doxygen will generate a detailed section even if there is only a brief 
-# description.
+OUTPUT_DIRECTORY       = $(output_dir)
 
 ALWAYS_DETAILED_SEC    = YES
-
-# If the INLINE_INHERITED_MEMB tag is set to YES, doxygen will show all 
-# inherited members of a class in the documentation of that class as if those 
-# members were ordinary class members. Constructors, destructors and assignment 
-# operators of the base classes will not be shown.
-
-INLINE_INHERITED_MEMB  = NO
-
-# If the FULL_PATH_NAMES tag is set to YES then Doxygen will prepend the full 
-# path before files name in the file list and in the header files. If set 
-# to NO the shortest path that makes the file name unique will be used.
-
-FULL_PATH_NAMES        = YES
-
-# If the FULL_PATH_NAMES tag is set to YES then the STRIP_FROM_PATH tag 
-# can be used to strip a user-defined part of the path. Stripping is 
-# only done if one of the specified strings matches the left-hand part of 
-# the path. The tag can be used to show relative paths in the file list. 
-# If left blank the directory from which doxygen is run is used as the 
-# path to strip.
-
-##STRIP_FROM_PATH        = 
-
-# The STRIP_FROM_INC_PATH tag can be used to strip a user-defined part of 
-# the path mentioned in the documentation of a class, which tells 
-# the reader which header file to include in order to use a class. 
-# If left blank only the name of the header file containing the class 
-# definition is used. Otherwise one should specify the include paths that 
-# are normally passed to the compiler using the -I flag.
-
 STRIP_FROM_INC_PATH    = $(TOPDIR)
-
-# If the SHORT_NAMES tag is set to YES, doxygen will generate much shorter 
-# (but less readable) file names. This can be useful is your file systems 
-# doesn't support long names like on DOS, Mac, or CD-ROM.
-
-SHORT_NAMES            = NO
-
-# If the JAVADOC_AUTOBRIEF tag is set to YES then Doxygen 
-# will interpret the first line (until the first dot) of a JavaDoc-style 
-# comment as the brief description. If set to NO, the JavaDoc 
-# comments will behave just like regular Qt-style comments 
-# (thus requiring an explicit @brief command for a brief description.)
-
-JAVADOC_AUTOBRIEF      = NO
-
-# If the QT_AUTOBRIEF tag is set to YES then Doxygen will 
-# interpret the first line (until the first dot) of a Qt-style 
-# comment as the brief description. If set to NO, the comments 
-# will behave just like regular Qt-style comments (thus requiring 
-# an explicit \brief command for a brief description.)
-
-QT_AUTOBRIEF           = NO
-
-# The MULTILINE_CPP_IS_BRIEF tag can be set to YES to make Doxygen 
-# treat a multi-line C++ special comment block (i.e. a block of //! or /// 
-# comments) as a brief description. This used to be the default behaviour. 
-# The new default is to treat a multi-line C++ comment block as a detailed 
-# description. Set this tag to YES if you prefer the old behaviour instead.
-
 MULTILINE_CPP_IS_BRIEF = YES
-
-# If the DETAILS_AT_TOP tag is set to YES then Doxygen 
-# will output the detailed description near the top, like JavaDoc.
-# If set to NO, the detailed description appears after the member 
-# documentation.
-
 DETAILS_AT_TOP         = YES
 LAYOUT_FILE            = $(TOPDIR)/doclib/DoxygenLayout.xml
 
-# If the INHERIT_DOCS tag is set to YES (the default) then an undocumented 
-# member inherits the documentation from any documented member that it 
-# re-implements.
-
-INHERIT_DOCS           = YES
-
-# If the SEPARATE_MEMBER_PAGES tag is set to YES, then doxygen will produce 
-# a new page for each member. If set to NO, the documentation of a member will 
-# be part of the file/class/namespace that contains it.
-
-SEPARATE_MEMBER_PAGES  = NO
-
-# The TAB_SIZE tag can be used to set the number of spaces in a tab. 
-# Doxygen uses this value to replace tabs by spaces in code fragments.
-
-TAB_SIZE               = 8
-
-# This tag can be used to specify a number of aliases that acts 
-# as commands in the documentation. An alias has the form "name=value". 
-# For example adding "sideeffect=\par Side Effects:\n" will allow you to 
-# put the command \sideeffect (or @sideeffect) in the documentation, which 
-# will result in a user-defined paragraph with heading "Side Effects:". 
-# You can put \n's in the value part of an alias to insert newlines.
-
 ALIASES                = "fixme=\xrefitem fixme \"Fix\" \"Fixmes\"" \
                          "idea=\xrefitem idea \"Idea\" \"Ideas\"" \
                          "implementation=\par \"Implementation note:\"" \
@@ -194,348 +15,13 @@ ALIASES                = "fixme=\xrefitem fixme \"Fix\" \"Fixmes\"" \
                          "autotoc=\htmlonly <div id=\"autotoc\"></div> \endhtmlonly" \
                          "seechapter=<b>\htmlonly &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&rarr;&nbsp;\endhtmlonly see </b>"
 
-# Set the OPTIMIZE_OUTPUT_FOR_C tag to YES if your project consists of C 
-# sources only. Doxygen will then generate output that is more tailored for C. 
-# For instance, some of the names that are used will be different. The list 
-# of all members will be omitted, etc.
-
-OPTIMIZE_OUTPUT_FOR_C  = NO
-
-# Set the OPTIMIZE_OUTPUT_JAVA tag to YES if your project consists of Java 
-# sources only. Doxygen will then generate output that is more tailored for 
-# Java. For instance, namespaces will be presented as packages, qualified 
-# scopes will look different, etc.
-
-OPTIMIZE_OUTPUT_JAVA   = NO
-
-# Set the OPTIMIZE_FOR_FORTRAN tag to YES if your project consists of Fortran 
-# sources only. Doxygen will then generate output that is more tailored for 
-# Fortran.
-
-OPTIMIZE_FOR_FORTRAN   = NO
-
-# Set the OPTIMIZE_OUTPUT_VHDL tag to YES if your project consists of VHDL 
-# sources. Doxygen will then generate output that is tailored for 
-# VHDL.
-
-OPTIMIZE_OUTPUT_VHDL   = NO
-
-# If you use STL classes (i.e. std::string, std::vector, etc.) but do not want 
-# to include (a tag file for) the STL sources as input, then you should 
-# set this tag to YES in order to let doxygen match functions declarations and 
-# definitions whose arguments contain STL classes (e.g. func(std::string); v.s. 
-# func(std::string) {}). This also make the inheritance and collaboration 
-# diagrams that involve STL classes more complete and accurate.
-
 BUILTIN_STL_SUPPORT    = YES
 
-# If you use Microsoft's C++/CLI language, you should set this option to YES to
-# enable parsing support.
-
-CPP_CLI_SUPPORT        = NO
-
-# Set the SIP_SUPPORT tag to YES if your project consists of sip sources only. 
-# Doxygen will parse them like normal C++ but will assume all classes use public 
-# instead of private inheritance when no explicit protection keyword is present.
-
-SIP_SUPPORT            = NO
-
-# If member grouping is used in the documentation and the DISTRIBUTE_GROUP_DOC 
-# tag is set to YES, then doxygen will reuse the documentation of the first 
-# member in the group (if any) for the other members of the group. By default 
-# all members of a group must be documented explicitly.
-
-DISTRIBUTE_GROUP_DOC   = NO
-
-# Set the SUBGROUPING tag to YES (the default) to allow class member groups of 
-# the same type (for instance a group of public functions) to be put as a 
-# subgroup of that type (e.g. under the Public Functions section). Set it to 
-# NO to prevent subgrouping. Alternatively, this can be done per class using 
-# the \nosubgrouping command.
-
 SUBGROUPING            = NO
-
-# When TYPEDEF_HIDES_STRUCT is enabled, a typedef of a struct, union, or enum 
-# is documented as struct, union, or enum with the name of the typedef. So 
-# typedef struct TypeS {} TypeT, will appear in the documentation as a struct 
-# with name TypeT. When disabled the typedef will appear as a member of a file, 
-# namespace, or class. And the struct will be named TypeS. This can typically 
-# be useful for C code in case the coding convention dictates that all compound 
-# types are typedef'ed and only the typedef is referenced, never the tag name.
-
-TYPEDEF_HIDES_STRUCT   = NO
-
-#---------------------------------------------------------------------------
-# Build related configuration options
-#---------------------------------------------------------------------------
-
-# If the EXTRACT_ALL tag is set to YES doxygen will assume all entities in 
-# documentation are documented, even if no documentation was available. 
-# Private class members and static file members will be hidden unless 
-# the EXTRACT_PRIVATE and EXTRACT_STATIC tags are set to YES
-
 EXTRACT_ALL            = YES
-
-# If the EXTRACT_PRIVATE tag is set to YES all private members of a class 
-# will be included in the documentation.
-
-EXTRACT_PRIVATE        = NO
-
-# If the EXTRACT_STATIC tag is set to YES all static members of a file 
-# will be included in the documentation.
-
-EXTRACT_STATIC         = NO
-
-# If the EXTRACT_LOCAL_CLASSES tag is set to YES classes (and structs) 
-# defined locally in source files will be included in the documentation. 
-# If set to NO only classes defined in header files are included.
-
-EXTRACT_LOCAL_CLASSES  = YES
-
-# This flag is only useful for Objective-C code. When set to YES local 
-# methods, which are defined in the implementation section but not in 
-# the interface are included in the documentation. 
-# If set to NO (the default) only methods in the interface are included.
-
-EXTRACT_LOCAL_METHODS  = NO
-
-# If this flag is set to YES, the members of anonymous namespaces will be 
-# extracted and appear in the documentation as a namespace called 
-# 'anonymous_namespace{file}', where file will be replaced with the base 
-# name of the file that contains the anonymous namespace. By default 
-# anonymous namespace are hidden.
-
-EXTRACT_ANON_NSPACES   = NO
-
-# If the HIDE_UNDOC_MEMBERS tag is set to YES, Doxygen will hide all 
-# undocumented members of documented classes, files or namespaces. 
-# If set to NO (the default) these members will be included in the 
-# various overviews, but no documentation section is generated. 
-# This option has no effect if EXTRACT_ALL is enabled.
-
-HIDE_UNDOC_MEMBERS     = NO
-
-# If the HIDE_UNDOC_CLASSES tag is set to YES, Doxygen will hide all 
-# undocumented classes that are normally visible in the class hierarchy. 
-# If set to NO (the default) these classes will be included in the various 
-# overviews. This option has no effect if EXTRACT_ALL is enabled.
-
-HIDE_UNDOC_CLASSES     = NO
-
-# If the HIDE_FRIEND_COMPOUNDS tag is set to YES, Doxygen will hide all 
-# friend (class|struct|union) declarations. 
-# If set to NO (the default) these declarations will be included in the 
-# documentation.
-
 HIDE_FRIEND_COMPOUNDS  = YES
-
-# If the HIDE_IN_BODY_DOCS tag is set to YES, Doxygen will hide any 
-# documentation blocks found inside the body of a function. 
-# If set to NO (the default) these blocks will be appended to the 
-# function's detailed documentation block.
-
-HIDE_IN_BODY_DOCS      = NO
-
-# The INTERNAL_DOCS tag determines if documentation 
-# that is typed after a \internal command is included. If the tag is set 
-# to NO (the default) then the documentation will be excluded. 
-# Set it to YES to include the internal documentation.
-
 INTERNAL_DOCS          = YES
 
-# If the CASE_SENSE_NAMES tag is set to NO then Doxygen will only generate 
-# file names in lower-case letters. If set to YES upper-case letters are also 
-# allowed. This is useful if you have classes or files whose names only differ 
-# in case and if your file system supports case sensitive file names. Windows 
-# and Mac users are advised to set this option to NO.
-
-CASE_SENSE_NAMES       = YES
-
-# If the HIDE_SCOPE_NAMES tag is set to NO (the default) then Doxygen 
-# will show members with their full class and namespace scopes in the 
-# documentation. If set to YES the scope will be hidden.
-
-HIDE_SCOPE_NAMES       = NO
-
-# If the SHOW_INCLUDE_FILES tag is set to YES (the default) then Doxygen 
-# will put a list of the files that are included by a file in the documentation 
-# of that file.
-
-SHOW_INCLUDE_FILES     = YES
-
-# If the INLINE_INFO tag is set to YES (the default) then a tag [inline] 
-# is inserted in the documentation for inline members.
-
-INLINE_INFO            = YES
-
-# If the SORT_MEMBER_DOCS tag is set to YES (the default) then doxygen 
-# will sort the (detailed) documentation of file and class members 
-# alphabetically by member name. If set to NO the members will appear in 
-# declaration order.
-
-SORT_MEMBER_DOCS       = YES
-
-# If the SORT_BRIEF_DOCS tag is set to YES then doxygen will sort the 
-# brief documentation of file, namespace and class members alphabetically 
-# by member name. If set to NO (the default) the members will appear in 
-# declaration order.
-
-SORT_BRIEF_DOCS        = NO
-
-# If the SORT_GROUP_NAMES tag is set to YES then doxygen will sort the 
-# hierarchy of group names into alphabetical order. If set to NO (the default) 
-# the group names will appear in their defined order.
-
-SORT_GROUP_NAMES       = NO
-
-# If the SORT_BY_SCOPE_NAME tag is set to YES, the class list will be 
-# sorted by fully-qualified names, including namespaces. If set to 
-# NO (the default), the class list will be sorted only by class name, 
-# not including the namespace part. 
-# Note: This option is not very useful if HIDE_SCOPE_NAMES is set to YES.
-# Note: This option applies only to the class list, not to the 
-# alphabetical list.
-
-SORT_BY_SCOPE_NAME     = NO
-
-# The GENERATE_TODOLIST tag can be used to enable (YES) or 
-# disable (NO) the todo list. This list is created by putting \todo 
-# commands in the documentation.
-
-GENERATE_TODOLIST      = YES
-
-# The GENERATE_TESTLIST tag can be used to enable (YES) or 
-# disable (NO) the test list. This list is created by putting \test 
-# commands in the documentation.
-
-GENERATE_TESTLIST      = YES
-
-# The GENERATE_BUGLIST tag can be used to enable (YES) or 
-# disable (NO) the bug list. This list is created by putting \bug 
-# commands in the documentation.
-
-GENERATE_BUGLIST       = YES
-
-# The GENERATE_DEPRECATEDLIST tag can be used to enable (YES) or 
-# disable (NO) the deprecated list. This list is created by putting 
-# \deprecated commands in the documentation.
-
-GENERATE_DEPRECATEDLIST= YES
-
-# The ENABLED_SECTIONS tag can be used to enable conditional 
-# documentation sections, marked by \if sectionname ... \endif.
-
-##ENABLED_SECTIONS       = 
-
-# The MAX_INITIALIZER_LINES tag determines the maximum number of lines 
-# the initial value of a variable or define consists of for it to appear in 
-# the documentation. If the initializer consists of more lines than specified 
-# here it will be hidden. Use a value of 0 to hide initializers completely. 
-# The appearance of the initializer of individual variables and defines in the 
-# documentation can be controlled using \showinitializer or \hideinitializer 
-# command in the documentation regardless of this setting.
-
-MAX_INITIALIZER_LINES  = 30
-
-# Set the SHOW_USED_FILES tag to NO to disable the list of files generated 
-# at the bottom of the documentation of classes and structs. If set to YES the 
-# list will mention the files that were used to generate the documentation.
-
-SHOW_USED_FILES        = YES
-
-# If the sources in your project are distributed over multiple directories 
-# then setting the SHOW_DIRECTORIES tag to YES will show the directory hierarchy 
-# in the documentation. The default is NO.
-
-SHOW_DIRECTORIES       = NO
-
-# The FILE_VERSION_FILTER tag can be used to specify a program or script that 
-# doxygen should invoke to get the current version for each file (typically from 
-# the version control system). Doxygen will invoke the program by executing (via 
-# popen()) the command <command> <input-file>, where <command> is the value of 
-# the FILE_VERSION_FILTER tag, and <input-file> is the name of an input file 
-# provided by doxygen. Whatever the program writes to standard output 
-# is used as the file version. See the manual for examples.
-
-##FILE_VERSION_FILTER    = 
-
-#---------------------------------------------------------------------------
-# configuration options related to warning and progress messages
-#---------------------------------------------------------------------------
-
-# The QUIET tag can be used to turn on/off the messages that are generated 
-# by doxygen. Possible values are YES and NO. If left blank NO is used.
-
-QUIET                  = NO
-
-# The WARNINGS tag can be used to turn on/off the warning messages that are 
-# generated by doxygen. Possible values are YES and NO. If left blank 
-# NO is used.
-
-WARNINGS               = YES
-
-# If WARN_IF_UNDOCUMENTED is set to YES, then doxygen will generate warnings 
-# for undocumented members. If EXTRACT_ALL is set to YES then this flag will 
-# automatically be disabled.
-
-WARN_IF_UNDOCUMENTED   = YES
-
-# If WARN_IF_DOC_ERROR is set to YES, doxygen will generate warnings for 
-# potential errors in the documentation, such as not documenting some 
-# parameters in a documented function, or documenting parameters that 
-# don't exist or using markup commands wrongly.
-
-WARN_IF_DOC_ERROR      = YES
-
-# This WARN_NO_PARAMDOC option can be abled to get warnings for 
-# functions that are documented, but have no documentation for their parameters 
-# or return value. If set to NO (the default) doxygen will only warn about 
-# wrong or incomplete parameter documentation, but not about the absence of 
-# documentation.
-
-WARN_NO_PARAMDOC       = NO
-
-# The WARN_FORMAT tag determines the format of the warning messages that 
-# doxygen can produce. The string should contain the $file, $line, and $text 
-# tags, which will be replaced by the file and line number from which the 
-# warning originated and the warning text. Optionally the format may contain 
-# $version, which will be replaced by the version of the file (if it could 
-# be obtained via FILE_VERSION_FILTER)
-
-WARN_FORMAT            = "$file:$line: $text"
-
-# The WARN_LOGFILE tag can be used to specify a file to which warning 
-# and error messages should be written. If left blank the output is written 
-# to stderr.
-
-##WARN_LOGFILE           = 
-
-#---------------------------------------------------------------------------
-# configuration options related to the input files
-#---------------------------------------------------------------------------
-
-# The INPUT tag can be used to specify the files and/or directories that contain 
-# documented source files. You may enter file names like "myfile.cpp" or 
-# directories like "/usr/src/myproject". Separate the files or directories 
-# with spaces.
-
-##INPUT                = .
-
-# This tag can be used to specify the character encoding of the source files 
-# that doxygen parses. Internally doxygen uses the UTF-8 encoding, which is 
-# also the default input encoding. Doxygen uses libiconv (or the iconv built 
-# into libc) for the transcoding. See http://www.gnu.org/software/libiconv for 
-# the list of possible encodings.
-
-INPUT_ENCODING         = UTF-8
-
-# If the value of the INPUT tag contains directories, you can use the 
-# FILE_PATTERNS tag to specify one or more wildcard pattern (like *.cpp 
-# and *.h) to filter out the source-files in the directories. If left 
-# blank the following patterns are tested: 
-# *.c *.cc *.cxx *.cpp *.c++ *.java *.ii *.ixx *.ipp *.i++ *.inl *.h *.hh *.hxx 
-# *.hpp *.h++ *.idl *.odl *.cs *.php *.php3 *.inc *.m *.mm *.py *.f90
-
 FILE_PATTERNS          = *.c \
                          *.cc \
                          *.cci \
@@ -546,594 +32,31 @@ FILE_PATTERNS          = *.c \
                          *.ih \
                          *.mpp \
                          *.dox
-
-# The RECURSIVE tag can be used to turn specify whether or not subdirectories 
-# should be searched for input files as well. Possible values are YES and NO. 
-# If left blank NO is used.
-
 RECURSIVE              = NO
-
-# The EXCLUDE tag can be used to specify files and/or directories that should 
-# excluded from the INPUT source files. This way you can easily exclude a 
-# subdirectory from a directory tree whose root is specified with the INPUT tag.
-
-##EXCLUDE                = 
-
-# The EXCLUDE_SYMLINKS tag can be used select whether or not files or 
-# directories that are symbolic links (a Unix filesystem feature) are excluded 
-# from the input.
-
-EXCLUDE_SYMLINKS       = NO
-
-# If the value of the INPUT tag contains directories, you can use the 
-# EXCLUDE_PATTERNS tag to specify one or more wildcard patterns to exclude 
-# certain files from those directories. Note that the wildcards are matched 
-# against the file with absolute path, so to exclude all test directories 
-# for example use the pattern */test/*
-
 EXCLUDE_PATTERNS       = *.test.cc \
                          *.test.hh \
                          .* \
                          *~ \
                          "#*#"
-
-# The EXCLUDE_SYMBOLS tag can be used to specify one or more symbol names 
-# (namespaces, classes, functions, etc.) that should be excluded from the 
-# output. The symbol name can be a fully qualified name, a word, or if the 
-# wildcard * is used, a substring. Examples: ANamespace, AClass, 
-# AClass::ANamespace, ANamespace::*Test
-
 EXCLUDE_SYMBOLS        = boost std
-
-# The EXAMPLE_PATH tag can be used to specify one or more files or 
-# directories that contain example code fragments that are included (see 
-# the \include command).
-
-##EXAMPLE_PATH           = 
-
-# If the value of the EXAMPLE_PATH tag contains directories, you can use the 
-# EXAMPLE_PATTERNS tag to specify one or more wildcard pattern (like *.cpp 
-# and *.h) to filter out the source-files in the directories. If left 
-# blank all files are included.
-
-##EXAMPLE_PATTERNS       = 
-
-# If the EXAMPLE_RECURSIVE tag is set to YES then subdirectories will be 
-# searched for input files to be used with the \include or \dontinclude 
-# commands irrespective of the value of the RECURSIVE tag. 
-# Possible values are YES and NO. If left blank NO is used.
-
-EXAMPLE_RECURSIVE      = NO
-
-# The IMAGE_PATH tag can be used to specify one or more files or 
-# directories that contain image that are included in the documentation (see 
-# the \image command).
-
 IMAGE_PATH             = .
-
-# The INPUT_FILTER tag can be used to specify a program that doxygen should 
-# invoke to filter for each input file. Doxygen will invoke the filter program 
-# by executing (via popen()) the command <filter> <input-file>, where <filter> 
-# is the value of the INPUT_FILTER tag, and <input-file> is the name of an 
-# input file. Doxygen will then use the output that the filter program writes 
-# to standard output.  If FILTER_PATTERNS is specified, this tag will be 
-# ignored.
-
 INPUT_FILTER           = "$(TOPDIR)/doclib/filter.pl"
 
-# The FILTER_PATTERNS tag can be used to specify filters on a per file pattern 
-# basis.  Doxygen will compare the file name with each pattern and apply the 
-# filter if there is a match.  The filters are a list of the form: 
-# pattern=filter (like *.cpp=my_cpp_filter). See INPUT_FILTER for further 
-# info on how filters are used. If FILTER_PATTERNS is empty, INPUT_FILTER 
-# is applied to all files.
-
-##FILTER_PATTERNS        = 
-
-# If the FILTER_SOURCE_FILES tag is set to YES, the input filter (if set using 
-# INPUT_FILTER) will be used to filter the input files when producing source 
-# files to browse (i.e. when SOURCE_BROWSER is set to YES).
-
-FILTER_SOURCE_FILES    = NO
-
-#---------------------------------------------------------------------------
-# configuration options related to source browsing
-#---------------------------------------------------------------------------
-
-# If the SOURCE_BROWSER tag is set to YES then a list of source files will 
-# be generated. Documented entities will be cross-referenced with these sources. 
-# Note: To get rid of all source code in the generated output, make sure also 
-# VERBATIM_HEADERS is set to NO.
-
 SOURCE_BROWSER         = YES
-
-# Setting the INLINE_SOURCES tag to YES will include the body 
-# of functions and classes directly in the documentation.
-
-INLINE_SOURCES         = NO
-
-# Setting the STRIP_CODE_COMMENTS tag to YES (the default) will instruct 
-# doxygen to hide any special comment blocks from generated source code 
-# fragments. Normal C and C++ comments will always remain visible.
-
-STRIP_CODE_COMMENTS    = YES
-
-# If the REFERENCED_BY_RELATION tag is set to YES (the default) 
-# then for each documented function all documented 
-# functions referencing it will be listed.
-
-REFERENCED_BY_RELATION = NO
-
-# If the REFERENCES_RELATION tag is set to YES (the default) 
-# then for each documented function all documented entities 
-# called/used by that function will be listed.
-
-REFERENCES_RELATION    = NO
-
-# If the REFERENCES_LINK_SOURCE tag is set to YES (the default)
-# and SOURCE_BROWSER tag is set to YES, then the hyperlinks from
-# functions in REFERENCES_RELATION and REFERENCED_BY_RELATION lists will
-# link to the source code.  Otherwise they will link to the documentstion.
-
-REFERENCES_LINK_SOURCE = YES
-
-# If the USE_HTAGS tag is set to YES then the references to source code 
-# will point to the HTML generated by the htags(1) tool instead of doxygen 
-# built-in source browser. The htags tool is part of GNU's global source 
-# tagging system (see http://www.gnu.org/software/global/global.html). You 
-# will need version 4.8.6 or higher.
-
-USE_HTAGS              = NO
-
-# If the VERBATIM_HEADERS tag is set to YES (the default) then Doxygen 
-# will generate a verbatim copy of the header file for each class for 
-# which an include is specified. Set to NO to disable this.
-
-VERBATIM_HEADERS       = YES
-
-#---------------------------------------------------------------------------
-# configuration options related to the alphabetical class index
-#---------------------------------------------------------------------------
-
-# If the ALPHABETICAL_INDEX tag is set to YES, an alphabetical index 
-# of all compounds will be generated. Enable this if the project 
-# contains a lot of classes, structs, unions or interfaces.
-
 ALPHABETICAL_INDEX     = YES
-
-# If the alphabetical index is enabled (see ALPHABETICAL_INDEX) then 
-# the COLS_IN_ALPHA_INDEX tag can be used to specify the number of columns 
-# in which this list will be split (can be a number in the range [1..20])
-
 COLS_IN_ALPHA_INDEX    = 3
 
-# In case all classes in a project start with a common prefix, all 
-# classes will be put under the same header in the alphabetical index. 
-# The IGNORE_PREFIX tag can be used to specify one or more prefixes that 
-# should be ignored while generating the index headers.
-
-##IGNORE_PREFIX          = 
-
-#---------------------------------------------------------------------------
-# configuration options related to the HTML output
-#---------------------------------------------------------------------------
-
-# If the GENERATE_HTML tag is set to YES (the default) Doxygen will 
-# generate HTML output.
-
-GENERATE_HTML          = YES
-
-# The HTML_OUTPUT tag is used to specify where the HTML docs will be put. 
-# If a relative path is entered the value of OUTPUT_DIRECTORY will be 
-# put in front of it. If left blank `html' will be used as the default path.
-
-HTML_OUTPUT            = html
-
-# The HTML_FILE_EXTENSION tag can be used to specify the file extension for 
-# each generated HTML page (for example: .htm,.php,.asp). If it is left blank 
-# doxygen will generate files with .html extension.
-
-HTML_FILE_EXTENSION    = .html
-
-# The HTML_HEADER tag can be used to specify a personal HTML header for 
-# each generated HTML page. If it is left blank doxygen will generate a 
-# standard header.
-
+GENERATE_HTML          = $(html)
+HTML_OUTPUT            = $(html_dir)
 HTML_HEADER            = "$(TOPDIR)/doclib/doxy-header.html"
-
-# The HTML_FOOTER tag can be used to specify a personal HTML footer for 
-# each generated HTML page. If it is left blank doxygen will generate a 
-# standard footer.
-
 HTML_FOOTER            = "$(TOPDIR)/doclib/doxy-footer.html"
 
-# The HTML_STYLESHEET tag can be used to specify a user-defined cascading 
-# style sheet that is used by each HTML page. It can be used to 
-# fine-tune the look of the HTML output. If the tag is left blank doxygen 
-# will generate a default style sheet. Note that doxygen will try to copy 
-# the style sheet file to the HTML output directory, so don't put your own 
-# stylesheet in the HTML output directory as well, or it will be erased!
-
-##HTML_STYLESHEET        = 
-
-# If the HTML_ALIGN_MEMBERS tag is set to YES, the members of classes, 
-# files or namespaces will be aligned in HTML using tables. If set to 
-# NO a bullet list will be used.
-
-HTML_ALIGN_MEMBERS     = YES
-
-# If the GENERATE_HTMLHELP tag is set to YES, additional index files 
-# will be generated that can be used as input for tools like the 
-# Microsoft HTML help workshop to generate a compiled HTML help file (.chm) 
-# of the generated HTML documentation.
-
-GENERATE_HTMLHELP      = NO
-
-# If the GENERATE_DOCSET tag is set to YES, additional index files 
-# will be generated that can be used as input for Apple's Xcode 3 
-# integrated development environment, introduced with OSX 10.5 (Leopard). 
-# To create a documentation set, doxygen will generate a Makefile in the 
-# HTML output directory. Running make will produce the docset in that 
-# directory and running "make install" will install the docset in 
-# ~/Library/Developer/Shared/Documentation/DocSets so that Xcode will find 
-# it at startup.
-
-GENERATE_DOCSET        = NO
-
-# When GENERATE_DOCSET tag is set to YES, this tag determines the name of the 
-# feed. A documentation feed provides an umbrella under which multiple 
-# documentation sets from a single provider (such as a company or product suite) 
-# can be grouped.
-
-DOCSET_FEEDNAME        = "Doxygen generated docs"
-
-# When GENERATE_DOCSET tag is set to YES, this tag specifies a string that 
-# should uniquely identify the documentation set bundle. This should be a 
-# reverse domain-name style string, e.g. com.mycompany.MyDocSet. Doxygen 
-# will append .docset to the name.
-
-DOCSET_BUNDLE_ID       = org.doxygen.Project
-
-# If the HTML_DYNAMIC_SECTIONS tag is set to YES then the generated HTML 
-# documentation will contain sections that can be hidden and shown after the 
-# page has loaded. For this to work a browser that supports 
-# JavaScript and DHTML is required (for instance Mozilla 1.0+, Firefox 
-# Netscape 6.0+, Internet explorer 5.0+, Konqueror, or Safari).
-
-HTML_DYNAMIC_SECTIONS  = NO
-
-# If the GENERATE_HTMLHELP tag is set to YES, the CHM_FILE tag can 
-# be used to specify the file name of the resulting .chm file. You 
-# can add a path in front of the file if the result should not be 
-# written to the html output directory.
-
-##CHM_FILE               = 
-
-# If the GENERATE_HTMLHELP tag is set to YES, the HHC_LOCATION tag can 
-# be used to specify the location (absolute path including file name) of 
-# the HTML help compiler (hhc.exe). If non-empty doxygen will try to run 
-# the HTML help compiler on the generated index.hhp.
-
-##HHC_LOCATION           = 
-
-# If the GENERATE_HTMLHELP tag is set to YES, the GENERATE_CHI flag 
-# controls if a separate .chi index file is generated (YES) or that 
-# it should be included in the master .chm file (NO).
-
-GENERATE_CHI           = NO
-
-# If the GENERATE_HTMLHELP tag is set to YES, the BINARY_TOC flag 
-# controls whether a binary table of contents is generated (YES) or a 
-# normal table of contents (NO) in the .chm file.
-
-BINARY_TOC             = NO
-
-# The TOC_EXPAND flag can be set to YES to add extra items for group members 
-# to the contents of the HTML help documentation and to the tree view.
-
-TOC_EXPAND             = NO
-
-# The DISABLE_INDEX tag can be used to turn on/off the condensed index at 
-# top of each HTML page. The value NO (the default) enables the index and 
-# the value YES disables it.
-
-DISABLE_INDEX          = NO
-
-# This tag can be used to set the number of enum values (range [1..20]) 
-# that doxygen will group on one line in the generated HTML documentation.
-
-ENUM_VALUES_PER_LINE   = 4
-
-# If the GENERATE_TREEVIEW tag is set to YES, a side panel will be
-# generated containing a tree-like index structure (just like the one that 
-# is generated for HTML Help). For this to work a browser that supports 
-# JavaScript, DHTML, CSS and frames is required (for instance Mozilla 1.0+, 
-# Netscape 6.0+, Internet explorer 5.0+, or Konqueror). Windows users are 
-# probably better off using the HTML help feature.
-
-GENERATE_TREEVIEW      = NO
-
-# If the treeview is enabled (see GENERATE_TREEVIEW) then this tag can be 
-# used to set the initial width (in pixels) of the frame in which the tree 
-# is shown.
-
-TREEVIEW_WIDTH         = 250
-
-#---------------------------------------------------------------------------
-# configuration options related to the LaTeX output
-#---------------------------------------------------------------------------
-
-# If the GENERATE_LATEX tag is set to YES (the default) Doxygen will 
-# generate Latex output.
-
 GENERATE_LATEX         = NO
-
-# The LATEX_OUTPUT tag is used to specify where the LaTeX docs will be put. 
-# If a relative path is entered the value of OUTPUT_DIRECTORY will be 
-# put in front of it. If left blank `latex' will be used as the default path.
-
-LATEX_OUTPUT           = latex
-
-# The LATEX_CMD_NAME tag can be used to specify the LaTeX command name to be 
-# invoked. If left blank `latex' will be used as the default command name.
-
-LATEX_CMD_NAME         = latex
-
-# The MAKEINDEX_CMD_NAME tag can be used to specify the command name to 
-# generate index for LaTeX. If left blank `makeindex' will be used as the 
-# default command name.
-
-MAKEINDEX_CMD_NAME     = makeindex
-
-# If the COMPACT_LATEX tag is set to YES Doxygen generates more compact 
-# LaTeX documents. This may be useful for small projects and may help to 
-# save some trees in general.
-
-COMPACT_LATEX          = NO
-
-# The PAPER_TYPE tag can be used to set the paper type that is used 
-# by the printer. Possible values are: a4, a4wide, letter, legal and 
-# executive. If left blank a4wide will be used.
-
-PAPER_TYPE             = a4wide
-
-# The EXTRA_PACKAGES tag can be to specify one or more names of LaTeX 
-# packages that should be included in the LaTeX output.
-
-##EXTRA_PACKAGES         = 
-
-# The LATEX_HEADER tag can be used to specify a personal LaTeX header for 
-# the generated latex document. The header should contain everything until 
-# the first chapter. If it is left blank doxygen will generate a 
-# standard header. Notice: only use this tag if you know what you are doing!
-
-##LATEX_HEADER           = 
-
-# If the PDF_HYPERLINKS tag is set to YES, the LaTeX that is generated 
-# is prepared for conversion to pdf (using ps2pdf). The pdf file will 
-# contain links (just like the HTML output) instead of page references 
-# This makes the output suitable for online browsing using a pdf viewer.
-
-PDF_HYPERLINKS         = YES
-
-# If the USE_PDFLATEX tag is set to YES, pdflatex will be used instead of 
-# plain latex in the generated Makefile. Set this option to YES to get a 
-# higher quality PDF documentation.
-
-USE_PDFLATEX           = YES
-
-# If the LATEX_BATCHMODE tag is set to YES, doxygen will add the \\batchmode. 
-# command to the generated LaTeX files. This will instruct LaTeX to keep 
-# running if errors occur, instead of asking the user for help. 
-# This option is also used when generating formulas in HTML.
-
-LATEX_BATCHMODE        = NO
-
-# If LATEX_HIDE_INDICES is set to YES then doxygen will not 
-# include the index chapters (such as File Index, Compound Index, etc.) 
-# in the output.
-
-LATEX_HIDE_INDICES     = NO
-
-#---------------------------------------------------------------------------
-# configuration options related to the RTF output
-#---------------------------------------------------------------------------
-
-# If the GENERATE_RTF tag is set to YES Doxygen will generate RTF output 
-# The RTF output is optimized for Word 97 and may not look very pretty with 
-# other RTF readers or editors.
-
-GENERATE_RTF           = NO
-
-# The RTF_OUTPUT tag is used to specify where the RTF docs will be put. 
-# If a relative path is entered the value of OUTPUT_DIRECTORY will be 
-# put in front of it. If left blank `rtf' will be used as the default path.
-
-RTF_OUTPUT             = rtf
-
-# If the COMPACT_RTF tag is set to YES Doxygen generates more compact 
-# RTF documents. This may be useful for small projects and may help to 
-# save some trees in general.
-
-COMPACT_RTF            = NO
-
-# If the RTF_HYPERLINKS tag is set to YES, the RTF that is generated 
-# will contain hyperlink fields. The RTF file will 
-# contain links (just like the HTML output) instead of page references. 
-# This makes the output suitable for online browsing using WORD or other 
-# programs which support those fields. 
-# Note: wordpad (write) and others do not support links.
-
-RTF_HYPERLINKS         = NO
-
-# Load stylesheet definitions from file. Syntax is similar to doxygen's 
-# config file, i.e. a series of assignments. You only have to provide 
-# replacements, missing definitions are set to their default value.
-
-##RTF_STYLESHEET_FILE    = 
-
-# Set optional variables used in the generation of an rtf document. 
-# Syntax is similar to doxygen's config file.
-
-##RTF_EXTENSIONS_FILE    = 
-
-#---------------------------------------------------------------------------
-# configuration options related to the man page output
-#---------------------------------------------------------------------------
-
-# If the GENERATE_MAN tag is set to YES (the default) Doxygen will 
-# generate man pages
-
+GENERATE_XML           = NO
 GENERATE_MAN           = NO
 
-# The MAN_OUTPUT tag is used to specify where the man pages will be put. 
-# If a relative path is entered the value of OUTPUT_DIRECTORY will be 
-# put in front of it. If left blank `man' will be used as the default path.
-
-MAN_OUTPUT             = man
-
-# The MAN_EXTENSION tag determines the extension that is added to 
-# the generated man pages (default is the subroutine's section .3)
-
-MAN_EXTENSION          = .3
-
-# If the MAN_LINKS tag is set to YES and Doxygen generates man output, 
-# then it will generate one additional man file for each entity 
-# documented in the real man page(s). These additional files 
-# only source the real man page, but without them the man command 
-# would be unable to find the correct page. The default is NO.
-
-MAN_LINKS              = NO
-
-#---------------------------------------------------------------------------
-# configuration options related to the XML output
-#---------------------------------------------------------------------------
-
-# If the GENERATE_XML tag is set to YES Doxygen will 
-# generate an XML file that captures the structure of 
-# the code including all documentation.
-
-GENERATE_XML           = YES
-
-# The XML_OUTPUT tag is used to specify where the XML pages will be put. 
-# If a relative path is entered the value of OUTPUT_DIRECTORY will be 
-# put in front of it. If left blank `xml' will be used as the default path.
-
-XML_OUTPUT             = xml
-
-# The XML_SCHEMA tag can be used to specify an XML schema, 
-# which can be used by a validating XML parser to check the 
-# syntax of the XML files.
-
-##XML_SCHEMA             = 
-
-# The XML_DTD tag can be used to specify an XML DTD, 
-# which can be used by a validating XML parser to check the 
-# syntax of the XML files.
-
-##XML_DTD                = 
-
-# If the XML_PROGRAMLISTING tag is set to YES Doxygen will 
-# dump the program listings (including syntax highlighting 
-# and cross-referencing information) to the XML output. Note that 
-# enabling this will significantly increase the size of the XML output.
-
-XML_PROGRAMLISTING     = YES
-
-#---------------------------------------------------------------------------
-# configuration options for the AutoGen Definitions output
-#---------------------------------------------------------------------------
-
-# If the GENERATE_AUTOGEN_DEF tag is set to YES Doxygen will 
-# generate an AutoGen Definitions (see autogen.sf.net) file 
-# that captures the structure of the code including all 
-# documentation. Note that this feature is still experimental 
-# and incomplete at the moment.
-
-GENERATE_AUTOGEN_DEF   = NO
-
-#---------------------------------------------------------------------------
-# configuration options related to the Perl module output
-#---------------------------------------------------------------------------
-
-# If the GENERATE_PERLMOD tag is set to YES Doxygen will 
-# generate a Perl module file that captures the structure of 
-# the code including all documentation. Note that this 
-# feature is still experimental and incomplete at the 
-# moment.
-
-GENERATE_PERLMOD       = NO
-
-# If the PERLMOD_LATEX tag is set to YES Doxygen will generate 
-# the necessary Makefile rules, Perl scripts and LaTeX code to be able 
-# to generate PDF and DVI output from the Perl module output.
-
-PERLMOD_LATEX          = NO
-
-# If the PERLMOD_PRETTY tag is set to YES the Perl module output will be 
-# nicely formatted so it can be parsed by a human reader.  This is useful 
-# if you want to understand what is going on.  On the other hand, if this 
-# tag is set to NO the size of the Perl module output will be much smaller 
-# and Perl will parse it just the same.
-
-PERLMOD_PRETTY         = YES
-
-# The names of the make variables in the generated doxyrules.make file 
-# are prefixed with the string contained in PERLMOD_MAKEVAR_PREFIX. 
-# This is useful so different doxyrules.make files included by the same 
-# Makefile don't overwrite each other's variables.
-
-##PERLMOD_MAKEVAR_PREFIX = 
-
-#---------------------------------------------------------------------------
-# Configuration options related to the preprocessor   
-#---------------------------------------------------------------------------
-
-# If the ENABLE_PREPROCESSING tag is set to YES (the default) Doxygen will 
-# evaluate all C-preprocessor directives found in the sources and include 
-# files.
-
-ENABLE_PREPROCESSING   = YES
-
-# If the MACRO_EXPANSION tag is set to YES Doxygen will expand all macro 
-# names in the source code. If set to NO (the default) only conditional 
-# compilation will be performed. Macro expansion can be done in a controlled 
-# way by setting EXPAND_ONLY_PREDEF to YES.
-
 MACRO_EXPANSION        = YES
-
-# If the EXPAND_ONLY_PREDEF and MACRO_EXPANSION tags are both set to YES 
-# then the macro expansion is limited to the macros specified with the 
-# PREDEFINED and EXPAND_AS_DEFINED tags.
-
 EXPAND_ONLY_PREDEF     = YES
-
-# If the SEARCH_INCLUDES tag is set to YES (the default) the includes files 
-# in the INCLUDE_PATH (see below) will be search if a #include is found.
-
-SEARCH_INCLUDES        = YES
-
-# The INCLUDE_PATH tag can be used to specify one or more directories that 
-# contain include files that are not input files but should be processed by 
-# the preprocessor.
-
-##INCLUDE_PATH           = 
-
-# You can use the INCLUDE_FILE_PATTERNS tag to specify one or more wildcard 
-# patterns (like *.h and *.hpp) to filter out the header-files in the 
-# directories. If left blank, the patterns specified with FILE_PATTERNS will 
-# be used.
-
-##INCLUDE_FILE_PATTERNS  = 
-
-# The PREDEFINED tag can be used to specify one or more macro names that 
-# are defined before the preprocessor is started (similar to the -D option of 
-# gcc). The argument of the tag is a list of macros of the form: name 
-# or name=definition (no spaces). If the definition and the = are 
-# omitted =1 is assumed. To prevent a macro definition from being 
-# undefined via #undef or recursively expanded use the := operator 
-# instead of the = operator.
-
 PREDEFINED             = DOXYGEN \
                          "SENF_PPI_MODULE(x)=" \
                          "SENF_PARSER()=" \
@@ -1169,253 +92,26 @@ PREDEFINED             = DOXYGEN \
                          "SENF_LOG_DEFAULT_STREAM(stream)=" \
                          "BOOST_PP_ITERATE()=" \
                          "BOOST_PARAMETER_KEYWORD(ns, name)=unspecified_keyword_type name;"
-
-# If the MACRO_EXPANSION and EXPAND_ONLY_PREDEF tags are set to YES then 
-# this tag can be used to specify a list of macro names that should be expanded. 
-# The macro definition that is found in the sources will be used. 
-# Use the PREDEFINED tag if you want to use a different macro definition.
-
 EXPAND_AS_DEFINED      = prefix_ \
                          SENF_LOG_DEF_STREAM \
                          SENF_LOG_DEF_AREA \
                          SENF_LOG_DEF_AREA_I
 
-# If the SKIP_FUNCTION_MACROS tag is set to YES (the default) then 
-# doxygen's preprocessor will remove all function-like macros that are alone 
-# on a line, have an all uppercase name, and do not end with a semicolon. Such 
-# function macros are typically used for boiler-plate code, and will confuse 
-# the parser if not removed.
-
-SKIP_FUNCTION_MACROS   = YES
-
-#---------------------------------------------------------------------------
-# Configuration::additions related to external references   
-#---------------------------------------------------------------------------
-
-# The TAGFILES option can be used to specify one or more tagfiles. 
-# Optionally an initial location of the external documentation 
-# can be added for each tagfile. The format of a tag file without 
-# this location is as follows: 
-#   TAGFILES = file1 file2 ... 
-# Adding location for the tag files is done as follows: 
-#   TAGFILES = file1=loc1 "file2 = loc2" ... 
-# where "loc1" and "loc2" can be relative or absolute paths or 
-# URLs. If a location is present for each tag, the installdox tool 
-# does not have to be run to correct the links.
-# Note that each tag file must have a unique name
-# (where the name does NOT include the path)
-# If a tag file is not located in the directory in which doxygen 
-# is run, you must also specify the path to the tagfile here.
-
-##TAGFILES               = 
-
-# When a file name is specified after GENERATE_TAGFILE, doxygen will create 
-# a tag file that is based on the input files it reads.
-
-##GENERATE_TAGFILE       = 
-
-# If the ALLEXTERNALS tag is set to YES all external classes will be listed 
-# in the class index. If set to NO only the inherited external classes 
-# will be listed.
-
-ALLEXTERNALS           = NO
-
-# If the EXTERNAL_GROUPS tag is set to YES all external groups will be listed 
-# in the modules index. If set to NO, only the current project's groups will 
-# be listed.
-
-EXTERNAL_GROUPS        = YES
-
-# The PERL_PATH should be the absolute path and name of the perl script 
-# interpreter (i.e. the result of `which perl').
-
-PERL_PATH              = /usr/bin/perl
-
-#---------------------------------------------------------------------------
-# Configuration options related to the dot tool   
-#---------------------------------------------------------------------------
-
-# If the CLASS_DIAGRAMS tag is set to YES (the default) Doxygen will 
-# generate a inheritance diagram (in HTML, RTF and LaTeX) for classes with base 
-# or super classes. Setting the tag to NO turns the diagrams off. Note that 
-# this option is superseded by the HAVE_DOT option below. This is only a 
-# fallback. It is recommended to install and use dot, since it yields more 
-# powerful graphs.
-
-CLASS_DIAGRAMS         = YES
-
-# You can define message sequence charts within doxygen comments using the \msc 
-# command. Doxygen will then run the mscgen tool (see 
-# http://www.mcternan.me.uk/mscgen/) to produce the chart and insert it in the 
-# documentation. The MSCGEN_PATH tag allows you to specify the directory where 
-# the mscgen tool resides. If left empty the tool is assumed to be found in the 
-# default search path.
-
-##MSCGEN_PATH            = 
-
-# If set to YES, the inheritance and collaboration graphs will hide 
-# inheritance and usage relations if the target is undocumented 
-# or is not a class.
-
-HIDE_UNDOC_RELATIONS   = NO
-
-# If you set the HAVE_DOT tag to YES then doxygen will assume the dot tool is 
-# available from the path. This tool is part of Graphviz, a graph visualization 
-# toolkit from AT&T and Lucent Bell Labs. The other options in this section 
-# have no effect if this option is set to NO (the default)
+TAGFILES               = $(tagfiles)
+GENERATE_TAGFILE       = $(generate_tagfile)
+EXTERNAL_GROUPS        = NO
 
 HAVE_DOT               = YES
-
-# If the CLASS_GRAPH and HAVE_DOT tags are set to YES then doxygen 
-# will generate a graph for each documented class showing the direct and 
-# indirect inheritance relations. Setting this tag to YES will force the 
-# the CLASS_DIAGRAMS tag to NO.
-
-CLASS_GRAPH            = YES
-
-# If the COLLABORATION_GRAPH and HAVE_DOT tags are set to YES then doxygen 
-# will generate a graph for each documented class showing the direct and 
-# indirect implementation dependencies (inheritance, containment, and 
-# class references variables) of the class with other documented classes.
-
 COLLABORATION_GRAPH    = NO
-
-# If the GROUP_GRAPHS and HAVE_DOT tags are set to YES then doxygen 
-# will generate a graph for groups, showing the direct groups dependencies
-
 GROUP_GRAPHS           = NO
-
-# If the UML_LOOK tag is set to YES doxygen will generate inheritance and 
-# collaboration diagrams in a style similar to the OMG's Unified Modeling 
-# Language.
-
-UML_LOOK               = NO
-
-# If set to YES, the inheritance and collaboration graphs will show the 
-# relations between templates and their instances.
-
-TEMPLATE_RELATIONS     = NO
-
-# If the ENABLE_PREPROCESSING, SEARCH_INCLUDES, INCLUDE_GRAPH, and HAVE_DOT 
-# tags are set to YES then doxygen will generate a graph for each documented 
-# file showing the direct and indirect include dependencies of the file with 
-# other documented files.
-
-INCLUDE_GRAPH          = YES
-
-# If the ENABLE_PREPROCESSING, SEARCH_INCLUDES, INCLUDED_BY_GRAPH, and 
-# HAVE_DOT tags are set to YES then doxygen will generate a graph for each 
-# documented header file showing the documented files that directly or 
-# indirectly include this file.
-
-INCLUDED_BY_GRAPH      = YES
-
-# If the CALL_GRAPH and HAVE_DOT options are set to YES then 
-# doxygen will generate a call dependency graph for every global function 
-# or class method. Note that enabling this option will significantly increase 
-# the time of a run. So in most cases it will be better to enable call graphs 
-# for selected functions only using the \callgraph command.
-
-CALL_GRAPH             = NO
-
-# If the CALLER_GRAPH and HAVE_DOT tags are set to YES then 
-# doxygen will generate a caller dependency graph for every global function 
-# or class method. Note that enabling this option will significantly increase 
-# the time of a run. So in most cases it will be better to enable caller 
-# graphs for selected functions only using the \callergraph command.
-
-CALLER_GRAPH           = NO
-
-# If the GRAPHICAL_HIERARCHY and HAVE_DOT tags are set to YES then doxygen 
-# will graphical hierarchy of all classes instead of a textual one.
-
 GRAPHICAL_HIERARCHY    = NO
-
-# If the DIRECTORY_GRAPH, SHOW_DIRECTORIES and HAVE_DOT tags are set to YES 
-# then doxygen will show the dependencies a directory has on other directories 
-# in a graphical way. The dependency relations are determined by the #include
-# relations between the files in the directories.
-
 DIRECTORY_GRAPH        = NO
-
-# The DOT_IMAGE_FORMAT tag can be used to set the image format of the images 
-# generated by dot. Possible values are png, jpg, or gif
-# If left blank png will be used.
-
-DOT_IMAGE_FORMAT       = png
-
-# The tag DOT_PATH can be used to specify the path where the dot tool can be 
-# found. If left blank, it is assumed the dot tool can be found in the path.
-
 DOT_PATH               = "$(TOPDIR)/doclib"
-
-# The DOTFILE_DIRS tag can be used to specify one or more directories that 
-# contain dot files that are included in the documentation (see the 
-# \dotfile command).
-
-##DOTFILE_DIRS           = 
-
-# The MAX_DOT_GRAPH_MAX_NODES tag can be used to set the maximum number of 
-# nodes that will be shown in the graph. If the number of nodes in a graph 
-# becomes larger than this value, doxygen will truncate the graph, which is 
-# visualized by representing a node as a red box. Note that doxygen if the 
-# number of direct children of the root node in a graph is already larger than 
-# DOT_GRAPH_MAX_NODES then the graph will not be shown at all. Also note 
-# that the size of a graph can be further restricted by MAX_DOT_GRAPH_DEPTH.
-
 DOT_GRAPH_MAX_NODES    = 10
-
-# The MAX_DOT_GRAPH_DEPTH tag can be used to set the maximum depth of the 
-# graphs generated by dot. A depth value of 3 means that only nodes reachable 
-# from the root by following a path via at most 3 edges will be shown. Nodes 
-# that lay further from the root node will be omitted. Note that setting this 
-# option to 1 or 2 may greatly reduce the computation time needed for large 
-# code bases. Also note that the size of a graph can be further restricted by 
-# DOT_GRAPH_MAX_NODES. Using a depth of 0 means no depth restriction.
-
 MAX_DOT_GRAPH_DEPTH    = 5
-
-# Set the DOT_TRANSPARENT tag to YES to generate images with a transparent 
-# background. This is enabled by default, which results in a transparent 
-# background. Warning: Depending on the platform used, enabling this option 
-# may lead to badly anti-aliased labels on the edges of a graph (i.e. they 
-# become hard to read).
-
-DOT_TRANSPARENT        = YES
-
-# Set the DOT_MULTI_TARGETS tag to YES allow dot to generate multiple output 
-# files in one run (i.e. multiple -o and -T options on the command line). This 
-# makes dot run faster, but since only newer versions of dot (>1.8.10) 
-# support this, this feature is disabled by default.
-
 DOT_MULTI_TARGETS      = YES
-
-# If the GENERATE_LEGEND tag is set to YES (the default) Doxygen will 
-# generate a legend page explaining the meaning of the various boxes and 
-# arrows in the dot generated graphs.
-
-GENERATE_LEGEND        = YES
-
-# If the DOT_CLEANUP tag is set to YES (the default) Doxygen will 
-# remove the intermediate dot files that are used to generate 
-# the various graphs.
-
 DOT_CLEANUP            = NO
 
-#---------------------------------------------------------------------------
-# Configuration::additions related to the search engine   
-#---------------------------------------------------------------------------
-
-# The SEARCHENGINE tag specifies whether or not a search engine should be 
-# used. If set to NO the values of all tags below this one will be ignored.
-
 SEARCHENGINE           = YES
 
-#---------------------------------------------------------------------------
-
 @INCLUDE = "$(TOPDIR)/Doxyfile.local"
-
-# Local Variables:
-# mode: indented-text
-# indent-tabs-mode: nil
-# End:
index 94dcdc9..ab5a009 100644 (file)
@@ -1,9 +1,4 @@
 # -*- python -*-
-
-# Some internal information on how the documentation is generated. All
-# this is quite a mess, the complete documentation generation setup is
-# in dire need of a complete redesign, but ...
-# 
 #
 # The documentation generation process is tightly integrated with the
 # scons build framework:
 #   dependencies. This happens in the doxygen builder in
 #   senfscons/Doxygen.py.
 #
-# * possibly the doclib/doxy-header.html and/or
-#   doclib/doxy-footer.html files are regenerated
+# * the doclib/doxy-header.html and/or doclib/doxy-footer.html files
+#   are regenerated
 # 
 # * If any documentation is out-of-date with respect to it's source
 #   files, the documentation is regenerated.
 # 
-# * When building the complete documentation ('all_docs'), the
-#   cross-reference page will be rebuilt if necessary (The global list
-#   of 'Open Issues').
-#
-# * To fix some link errors, the additional 'linlint' and 'fixlinks'
+# * To fix some link errors, the additional 'linklint' and 'fixlinks'
 #   targets are used
 #
 # 
 # 3. Calling doxygen
 # 
 # The doxygen call itself is quite complex since there is some pre-
-# and post-processing going on. We can separate this step into tree
-# parts
+# and post-processing going on. We can separate this step into two
+# steps
 #
 # * Building prerequisites (e.g. images)
 #
-# * The processing done by the Doxygen builder
-#
-# * Additional processing added by the SENFSCons.Doxygen helper.
+# * The processing done by the Doxygen builder and doclib/doxygen.sh
 #
 #
 # 3.1. Building prerequisites
 #
 # 3.2. The main doxygen build (Doxygen builder)
 #
-# * doxygen proper is called
-# 
-# * doxygen is configured in Doxyfile.global to call
-#   'doclib/filter.pl' on each source file. This filter will strip
-#   excess whitespace from the beginning of lines in '\code' and
-#   '<pre>' blocks. Additionally it will expand all tabs, tab width is
-#   8 spaces (there should be no tabs in the source but ...)
+# The Doxygen builder will call the doxygen command to build the
+# documentation. 
+#
+# The doxygen command is configured as 'doclib/doxygen.sh' which
+# does some additional processing in addition to calling doxygen
+# proper
+#
+# * it sets environment variables depending on command line arguments.
+#   These variables are then used in the Doxyfile's
+#
+# * after doxygen is finished, 'installdox' is called to resolve 
+#   tag file references.
+#
+# * the HTML documentation is post-processed using some sed, tidy, and
+#   an XSLT template
+#
+# * a generated tag file is post-processed using an XSLT template
+#
+# (see doclib/doxygen.sh for more information). The Doxygen
+# configuration is set up such, that
+#
+# * doxygen calls 'doclib/filter.pl' on each source file. This filter
+#   will strip excess whitespace from the beginning of lines in
+#   '\code' and '<pre>' blocks. Additionally it will expand all tabs,
+#   tab width is 8 spaces (there should be no tabs in the source but
+#   ...)
 # 
-# * doxygen is configured in Doxyfile.global to call 'doclib/dot' to
-#   generate the 'dot' images.
+# * doxygen calls 'doclib/dot' to generate the 'dot' images.
 #
 # * 'doclib/dot' calls 'doclib/dot-munge.pl' on the .dot
 #    files. dot-munge.pl changes the font and font-size and adds
 #   the oposite rank direction (top-bottom vs. left-right). The image
 #   with the smaller width is selected and returned.
 #
-# * after doxygen is finished, the list of referenced tag-files is
-#   checked. For each tag file the directory is found, where the
-#   documentation is generated (by scanning the Doxyfile which is
-#   repsonsible for building the tag file). For every tag file, the
-#   correct 'installdox' command is generated.
-#
-# * The stamp files are created
-#
-#
-# 3.3. Postprocessing
-#
-# The following steps are mostly added to work around some stupid
-# doxygen problems
-#
-# * If a tag file is generated, 'senfscons/tagmunge.xsl' is called on the
-#   tag file. This XSLT stylesheet removes all namespace components
-#   from the tag file. Without this task, doxygen will completely barf
-#   when two different documentation parts have members in the same
-#   namespace.
-#
-# * All html files are processed by 'doclib/html-munge.xsl'. However,
-#   since the documentation generated by doxygen is completely invalid
-#   html we need to preprocess the html files with a simple 'sed'
-#   script and 'tidy' before 'xsltproc' even accepts the html code.
-#
-# * We use the generated xml output of doxygen to generate an XML
-#   fragment for the global cross reference. This fragment is
-#   generated by 'senfscons/xrefxtract.xslt'
-#
-#
-# 4. Building the global cross-reference
-#
-# The global cross reference is built from the cross-refernce
-# fragments generated for each of the documentation parts and from the
-# doxy-header.html/doxy-footer.html files. This conversion is
-# controlled by the 'senfscons/xrefhtml.xslt' stylesheet.
-#
 #
-# 5. Fixing broken links
+# 4. Fixing broken links
 #
 # After the documentation has been generated, additional calls first
 # to the 'linklint' and then to the 'fixlinks' target will try to fix
diff --git a/doclib/doxygen.sh b/doclib/doxygen.sh
new file mode 100755 (executable)
index 0000000..2992bd2
--- /dev/null
@@ -0,0 +1,180 @@
+#!/bin/sh -e
+
+do_html_cleanup()
+{
+    sed -e 's/id="current"/class="current"/' \
+       | tidy -ascii -q --wrap 0 --show-warnings no --fix-uri no \
+       | sed -e 's/name="\([^"]*\)"\([^>]*\) id="\1"/name="\1"\2/g' \
+       | xsltproc --novalid --nonet --html --stringparam topdir $TOPDIR "$base/html-munge.xsl" -
+}
+
+###########################################################################
+
+name="`basename "$0"`"; #`"
+base="`dirname "$0"`"; base="`cd "$base"; pwd`" #`"
+
+TEMP=`getopt -n $name -o '' -l html,tagfile,tagfile-name:,tagfiles:,output-dir:,html-dir:  -- "$@"`
+if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
+eval set -- "$TEMP"
+
+tagxsl="$base/tag-munge.xsl"
+
+html="NO"; tagfile="NO"; tagfile_name=""; tagfiles=""; output_dir="doc"; html_dir="html"
+
+while true; do
+    case "$1" in
+       --html) 
+           html="YES" ; shift ;;
+       --tagfile) 
+           tagfile="YES" ; shift ;;
+       --tagfile-name) 
+           tagfile_name="$2"; shift 2 ;;
+       --tagfiles) 
+           for f in $2; do
+               f="`readlink -mn "$f"`" #`"
+               tagfiles="$tagfiles${tagfiles:+ }$f"
+           done
+           shift 2
+           ;;
+       --output-dir)
+           output_dir="$2"; shift 2 ;;
+       --html-dir)
+           html_dir="$2"; shift 2 ;;
+       --)
+           shift; break ;;
+       *)
+           echo "Internal error: $*"; exit 1 ;;
+    esac
+done
+
+if [ -z "$1" ]; then
+    cat <<EOF
+Usage:
+    $name
+        [--html]
+        [--tagfile]
+        [--tagfile-name=<name>]
+        [--tagfiles=<files>]
+        [--output-dir=<dir>]
+        [--html-dir=<dir>]
+            <doxyfile-or-dir>
+EOF
+    exit 1
+fi
+
+if [ "$tagfile" == "YES" -a -z "$tagfile_name" ]; then
+    echo "--tagfile-name is required with --tagfile"
+    exit 1
+fi
+
+doxydir="$1"
+
+if [ -f "$doxydir" ]; then
+    doxydir="`dirname "$doxydir"`" #`"
+fi
+
+doxydir="`readlink -mn "$doxydir"`" #`"
+
+###########################################################################
+
+# Create relative path from absolute directory $1 to absolute path $2
+relpath()
+{
+    local src="${1#/}"
+    local dst="${2#/}"
+    while true; do
+       srcd="${src%%/*}"
+       dstd="${dst%%/*}"
+       if [ "$srcd" = "$dstd" ]; then
+           src="${src#*/}"
+           dst="${dst#*/}"
+       else
+           break
+       fi
+    done
+    echo "`echo "$src" | sed -e "s/[^\/]*/../g"`/$dst" # `"
+}
+
+# Log executed commands
+cmd()
+{
+    echo "+" "$@"
+    "$@"
+}
+
+html_cleanup()
+{
+    mv "$1" "${1}.orig"
+    do_html_cleanup <"${1}.orig" >"$1"
+}
+
+###########################################################################
+
+## Find $TOPDIR
+
+cd "$doxydir"
+while [ ! -r "SConstruct" -a "`pwd`" != "/" ]; do cd ..; done
+if [ ! -r "SConstruct" ]; then
+    echo "topdir not found"
+    exit 1;
+fi
+TOPDIR="`pwd`";
+cd "$doxydir"
+
+
+## Remove tagfile_name from list of tagfiles
+
+if [ -n "$tagfile_name" ]; then 
+    tagfile_name="`readlink -mn "$output_dir/$tagfile_name"`" #`"
+    x="$tagfiles"; tagfiles=""
+    for f in $x; do
+       if [ "$f" != "$tagfile_name" ]; then
+           tagfiles="$tagfiles${tagfiles:+ }$f"
+       fi
+    done
+fi
+
+## Call doxygen proper
+
+generate_tagfile=""
+if [ "$tagfile" == "YES" ]; then
+    generate_tagfile="$tagfile_name"
+fi
+export TOPDIR html tagfile tagfile_name tagfiles output_dir html_dir generate_tagfile
+
+cmd ${DOXYGEN:-doxygen}
+
+
+## Clean up tagfile, if generated
+
+if [ "$tagfile" == "YES" ]; then
+    mv "$tagfile_name" "${tagfile_name}.orig"
+    cmd xsltproc --novalid --nonet -o "$tagfile_name" "$tagxsl" "${tagfile_name}.orig"
+fi
+
+
+## Call installdox
+
+if [ -n "$tagfiles" ]; then
+    args=""
+    for f in $tagfiles; do
+       n="`basename "$f"`" #`"
+       d="`dirname "$f"`" #`"
+       url="`relpath "$doxydir/$output_dir/$html_dir" "$d/$html_dir"`" #`"
+       args="$args${args:+ }-l $n@$url"
+    done
+
+    (
+       cd "./$output_dir/$html_dir"
+       cmd "./installdox" $args
+    )
+fi
+
+
+## Postprocess html files, if generated
+
+if [ "$html" == "YES" ]; then
+    for h in "$doxydir/$output_dir/$html_dir"/*.html; do
+       cmd html_cleanup "$h"
+    done
+fi
index efff924..895330f 100755 (executable)
@@ -304,7 +304,6 @@ def parse_VECTOR(args, flags):
         sys.stderr.write("Failed to aprse VECTOR: %s\n" % args)
         return None
     field = dict(FIELD_TYPES.get(args[-1].split(':')[-1], {}))
-    print args,repr(field);
     field['name'] = args[0]
     field['repeat'] = True
     return field
@@ -415,7 +414,6 @@ def scanPackets(data):
                     minsize += field['size']
                 elif field.get('minsize', None) is not None:
                     minsize += field['minsize']
-        print name,minsize,maxsize
         if minsize is not None and maxsize is not None:
             if minsize == maxsize:
                 FIELD_TYPES[name] = { 'size' : minsize }
similarity index 100%
rename from senfscons/tagmunge.xsl
rename to doclib/tag-munge.xsl
index b1e9e85..f76c709 100644 (file)
@@ -6,5 +6,3 @@ FILE_PATTERNS = *.dox *.py
 EXCLUDE_PATTERNS += __init__.py
 OPTIMIZE_OUTPUT_JAVA = YES
 ALPHABETICAL_INDEX = NO
-
-GENERATE_TAGFILE  = doc/senfscons.tag
\ No newline at end of file
index 5e327fa..2de1bee 100644 (file)
@@ -254,7 +254,7 @@ def DoxyfileParse(env,file):
       return {}
    ENV = {}
    ENV.update(env.get("ENV",{}))
-   ENV['TOPDIR'] = env.Dir('#').abspath
+   ENV.update(env.get("DOXYENV", {}))
    parser = DoxyfileParser(file,ENV)
    try:
       parser.parse()
@@ -311,10 +311,9 @@ def DoxySourceScan(node, env, path):
 
    for key in dep_add_keys:
       if data.has_key(key):
-         elt = data[key]
-         if type(elt) is type ("") : elt = [ elt ]
+         elt = env.Flatten(env.subst_list(data[key]))
          sources.extend([ os.path.normpath(os.path.join(basedir,f))
-                          for f in elt ])
+                          for f in elt if f ])
 
    sources = map( lambda path: env.File(path), sources )
    return sources
@@ -337,7 +336,7 @@ def DoxyEmitter(source, target, env):
    data = DoxyfileParse(env, source[0].abspath)
 
    targets = []
-   if data.has_key("OUTPUT_DIRECTORY"):
+   if data.get("OUTPUT_DIRECTORY",""):
       out_dir = data["OUTPUT_DIRECTORY"]
       dir = env.Dir( os.path.join(source[0].dir.abspath, out_dir) )
       dir.sources = source
@@ -350,7 +349,7 @@ def DoxyEmitter(source, target, env):
    # add our output locations
    html_dir = None
    for (k, v) in output_formats.iteritems():
-      if data.get("GENERATE_" + k, v[0]).upper() == "YES":
+      if data.get("GENERATE_" + k, v[0]).upper() == "YES" and data.get(k + "_OUTPUT", v[1]):
          dir = env.Dir( os.path.join(source[0].dir.abspath, out_dir, data.get(k + "_OUTPUT", v[1])) )
          if k == "HTML" : html_dir = dir
          dir.sources = source
@@ -358,10 +357,10 @@ def DoxyEmitter(source, target, env):
          targets.append(node)
          if env.GetOption('clean'): targets.append(dir)
 
-   if data.has_key("GENERATE_TAGFILE") and html_dir:
+   if data.get("GENERATE_TAGFILE",""):
       targets.append(env.File( os.path.join(source[0].dir.abspath, data["GENERATE_TAGFILE"]) ))
 
-   if data.get("SEARCHENGINE","NO").upper() == "YES":
+   if data.get("SEARCHENGINE","NO").upper() == "YES" and html_dir:
       targets.append(env.File( os.path.join(html_dir.abspath, "search.idx") ))
 
    # don't clobber targets
@@ -391,53 +390,12 @@ def relpath(source, target):
                          target_elts[prefix_len:]))
 
 def DoxyGenerator(source, target, env, for_signature):
-
    data = DoxyfileParse(env, source[0].abspath)
-
-   actions = [ SCons.Action.Action("cd ${SOURCE.dir} && TOPDIR=%s ${DOXYGEN} ${SOURCE.file}"
-                                   % env.Dir('#').abspath) ]
-
-   # This will add automatic 'installdox' calls.
-   #
-   # For every referenced tagfile, the generator first checks for the
-   # existence of a construction variable '<name>_DOXY_URL' where
-   # '<name>' is the uppercased name of the tagfile sans extension
-   # (e.g. 'Utils.tag' -> 'UTILS_DOXY_URL'). If this variable exists,
-   # it must contain the url or path to the installed documentation
-   # corresponding to the tag file.
-   #
-   # Is the variable is not found and if a referenced tag file is a
-   # target within this same build, the generator will parse the
-   # 'Doxyfile' from which the tag file is built. It will
-   # automatically create the html directory from the information in
-   # that 'Doxyfile'.
-   #
-   # If for any referenced tagfile no url can be found, 'installdox'
-   # will *not* be called and a warning about the missing url is
-   # generated.
-
-   if data.get('GENERATE_HTML','YES').upper() == "YES":
-      output_dir = os.path.normpath(os.path.join( source[0].dir.abspath,
-                                                  data.get("OUTPUT_DIRECTORY","."),
-                                                  data.get("HTML_OUTPUT","html") ))
-      args = []
-      for tagfile in data.get('TAGFILES',[]):
-         url = env.get(os.path.splitext(os.path.basename(tagfile))[0].upper()+"_DOXY_URL", None)
-         if not url:
-            url = doxyNodeHtmlDir(
-               env,
-               env.File(os.path.normpath(os.path.join(str(source[0].dir), tagfile))))
-            if url : url = relpath(output_dir, url)
-         if not url:
-            print "WARNING:",source[0].abspath, ": missing tagfile url for", tagfile
-            args = None
-         if args is not None and url:
-            args.append("-l %s@%s" % ( os.path.basename(tagfile), url ))
-      if args:
-         actions.append(SCons.Action.Action('cd %s && ./installdox %s' % (output_dir, " ".join(args))))
-
-   actions.append(SCons.Action.Action([ "touch $TARGETS" ]))
-
+   actions = [ 
+      SCons.Action.Action("$DOXYGENCOM"),
+      SCons.Action.Action([ "touch $TARGETS" ]),
+      ]
+   
    return actions
 
 def generate(env):
@@ -452,12 +410,11 @@ def generate(env):
    )
 
    doxyfile_builder = env.Builder(
-      # scons 0.96.93 hang on the next line but I don't know hot to FIX the problem
       generator = DoxyGenerator,
       emitter = DoxyEmitter,
       target_factory = env.fs.Entry,
       single_source = True,
-      source_scanner =  doxyfile_scanner
+      source_scanner = doxyfile_scanner
    )
 
    env.Append(BUILDERS = {
@@ -465,7 +422,7 @@ def generate(env):
    })
 
    env.SetDefault(
-      DOXYGEN = 'doxygen',
+      DOXYGENCOM = 'cd ${SOURCE.dir} && doxygen ${SOURCE.file}'
    )
 
 def exists(env):
index 58a9841..b6862e5 100644 (file)
@@ -439,195 +439,66 @@ def InstallIncludeFiles(env, files):
 
 ## \brief Build documentation with doxygen
 #
-# The doxygen target helper will build software documentation using
-# the given \a doxyfile (which defaults to \c Doxyfile). The Doxygen
-# builder used supports automatic dependency generation (dependencies
-# are automatically generated from the parameters specified in the \a
-# doxyfile), automatic target emitters (the exact targets created are
-# found parsing the \a doxyfile) and lots of other features. See the
-# Doxygen builder documentation
-#
-# If \a extra_sources are given, the generated documentation will
-# depend on them. This can be used to build images or other
-# supplementary files.
-#
-# The doxygen target helper extends the builder with additional
-# functionality:
-#
-# \li Fix tagfiles by removing namespace entries. These entries only
-#     work for namespaces completely defined in a single module. As
-#     soon as another module (which references the tagfile) has it's
-#     own members in that namespace, the crosslinking will break.
-# \li If \c DOXY_HTML_XSL is defined as a construction environment
-#     variable, preprocess all generated html files (if html files are
-#     generated) by the given XSLT stylesheet. Since the HTML
-#     generated by doxygen is broken, we first filter the code through
-#     HTML-\c tidy and filter out some error messages.
-# \li If xml output is generated we create files \c bug.xmli and \c
-#     todo.xmli which contain all bugs and todo items specified in the
-#     sources. The format of these files is much more suited to
-#     postprocessing and is a more database like format as the doxygen
-#     generated files (which are more presentation oriented). if \c
-#     DOXY_XREF_TYPES is given, it will specify the cross reference
-#     types to support (defaults to \c bug and \c todo). See <a
-#     href="http://www.stack.nl/~dimitri/doxygen/commands.html#cmdxrefitem">\xrefitem</a>
-#     in the doxygen documentation.
-#
 # \ingroup target
 def Doxygen(env, doxyfile = "Doxyfile", extra_sources = []):
-    if not 'all' in BUILD_TARGETS and not 'doc' in BUILD_TARGETS and not 'all_docs' in BUILD_TARGETS:
-        return []
-    # ARGHHH !!! without the [:] we are changing the target list
-    #        ||| WITHIN THE DOXYGEN BUILDER
-    docs = env.Doxygen(doxyfile)[:]
-    xmlnode = None
-    htmlnode = None
-    tagnode = None
-    for doc in docs:
-        if isinstance(doc,SCons.Node.FS.Dir): continue
-        if doc.name == 'xml.stamp' : xmlnode = doc
-        if doc.name == 'html.stamp' : htmlnode = doc
-        if doc.name == 'search.idx' : continue
-        if os.path.splitext(doc.name)[1] == '.stamp' : continue # ignore other file stamps
-        # otherwise it must be the tag file
-        tagnode = doc
-
-    if tagnode:
-        # Postprocess the tag file to remove the (broken) namespace
-        # references
-        env.AddPostAction(
-            docs,
-            SCons.Action.Action("xsltproc --nonet -o %(target)s.temp %(template)s %(target)s && mv %(target)s.temp %(target)s"
-                       % { 'target': tagnode.abspath,
-                           'template': os.path.join(basedir,"tagmunge.xsl") }))
-
-    if htmlnode and env.get('DOXY_HTML_XSL'):
-        xslfile = env.File(env['DOXY_HTML_XSL'])
-        reltopdir = '../' * len(htmlnode.dir.abspath[len(env.Dir('#').abspath)+1:].split('/'))
-        if reltopdir : reltopdir = reltopdir[:-1]
-        else         : reltopdir = '.'
-        env.AddPostAction(
-            docs,
-            SCons.Action.Action(("for html in %s/*.html; do " +
-                        "    echo $$html;" +
-                        "    mv $${html} $${html}.orig;" +
-                        "    sed -e 's/id=\"current\"/class=\"current\"/' $${html}.orig" +
-                        "        | tidy -ascii -q --wrap 0 --show-warnings no --fix-uri no " +
-                        "        | sed -e 's/name=\"\([^\"]*\)\"\([^>]*\) id=\"\\1\"/name=\"\\1\"\\2/g'" +
-                        "        | xsltproc --novalid --nonet --html --stringparam topdir %s -o $${html} %s -;"
-                        "done; true")
-                       % (htmlnode.dir.abspath, reltopdir, xslfile.abspath)))
-        for doc in docs:
-            env.Depends(doc, xslfile)
-
-    if xmlnode:
-        xrefs = []
-        for type in env.get("DOXY_XREF_TYPES",[ "bug", "todo" ]):
-            xref = os.path.join(xmlnode.dir.abspath,type+".xml")
-            xref_pp = env.Command(xref+'i', [ xref, os.path.join(basedir,'xrefxtract.xslt'), xmlnode ],
-                                  [ "test -s $SOURCE && xsltproc --nonet -o $TARGET" +
-                                    " --stringparam module $MODULE" +
-                                    " --stringparam type $TYPE" +
-                                    " ${SOURCES[1]} $SOURCE || touch $TARGET" ],
-                                  MODULE = xmlnode.dir.dir.dir.abspath[
-                                               len(env.Dir('#').abspath)+1:],
-                                  TYPE = type)
-            env.SideEffect(xref, xmlnode)
-            env.AddPreAction(docs, "rm -f %s" % (xref,))
-            env.AddPostAction(docs, "test -r %s || touch %s" % (xref,xref))
-            xrefs.extend(xref_pp)
-        docs.extend(xrefs)
-
-    if extra_sources and htmlnode:
-        env.Depends(docs,
-                    [ env.CopyToDir( source=source, target=htmlnode.dir )
-                      for source in extra_sources ])
-
-    if extra_sources and xmlnode:
-        env.Depends(docs,
-                    [ env.CopyToDir( source=source, target=xmlnode.dir )
-                      for source in extra_sources ])
-
-    if not htmlnode and not xmlnode:
-        env.Depends(docs, extra_sources)
-
-    for doc in docs :
-        env.Alias('all_docs', doc)
-        env.Clean('all_docs', doc)
-        env.Clean('all', doc)
-
+    # There is one small problem we need to solve with this builder: The Doxygen builder reads
+    # the Doxyfile and thus depends on the environment variables set by doclib/doxygen.sh. We
+    # thus have to provide all necessary definitions here manually via DOXYENV !
+
+    if type(doxyfile) is type(""):
+        doxyfile = env.File(doxyfile)
+
+    # Module name is derived from the doxyfile path
+    # Utils/Console/Doxyfile -> Utils_Console
+    module = doxyfile.dir.abspath[len(env.Dir('#').abspath)+1:].replace('/','_')
+    if not module : module = "Main"
+
+    # Rule to generate tagfile
+    # (need to exclude the 'clean' case, otherwise we'll have duplicate nodes)
+    if not env.GetOption('clean'):
+        env.Append(ALL_TAGFILES =
+                   env.Doxygen(doxyfile,
+                               DOXYOPTS = [ '--tagfile-name', '"${MODULE}.tag"',
+                                            '--tagfile' ],
+                               DOXYENV  = { 'TOPDIR'          : env.Dir('#').abspath,
+                                            'output_dir'      : 'doc',
+                                            'html_dir'        : 'html',
+                                            'html'            : 'NO',
+                                            'generate_tagfile': 'doc/${MODULE}.tag' },
+                               MODULE   = module )[0].abspath)
+
+    # Rule to generate HTML documentation
+    doc = env.Doxygen(doxyfile,
+                      DOXYOPTS = [ '--tagfiles', '"$ALL_TAGFILES"',
+                                   '--tagfile-name', '"${MODULE}.tag"',
+                                   '--html' ],
+                      MODULE   = module,
+                      DOXYENV  = { 'TOPDIR'          : env.Dir('#').abspath,
+                                   'tagfiles'        : '${ALL_TAGFILES}',
+                                   'output_dir'      : 'doc',
+                                   'html_dir'        : 'html',
+                                   'html'            : 'YES' } )
+
+    # Copy the extra_sources (the images) into the documentation directory
+    # (need to exclude the 'clean' case otherwise there are multiple ways to clean the copies)
+    if not env.GetOption('clean'):
+        if extra_sources:
+            env.Depends(doc,
+                        [ env.CopyToDir( source=source, target=doc[0].dir )
+                          for source in extra_sources ])
+
+    # Install documentation into DOCINSTALLDIR
     l = len(env.Dir('#').abspath)
-    if htmlnode:
-        env.Alias('install_all',
-                  env.Command('$DOCINSTALLDIR' + htmlnode.dir.abspath[l:], htmlnode.dir,
-                              [ SCons.Defaults.Copy('$TARGET','$SOURCE') ]))
-    if tagnode:
-        env.Alias('install_all',
-                  env.Install( '$DOCINSTALLDIR' + tagnode.dir.abspath[l:],
-                               tagnode ))
+    env.Alias('install_all',
+              env.Command('$DOCINSTALLDIR' + doc[0].dir.abspath[l:], doc[0].dir,
+                          [ SCons.Defaults.Copy('$TARGET','$SOURCE') ]))
 
-    return docs
-
-## \brief Build combined doxygen cross-reference
-#
-# This command will build a complete cross-reference of \c xrefitems
-# accross all modules.
-#
-# Right now, this command is very project specific. It needs to be
-# generalized.
-#
-# \ingroup target
-def DoxyXRef(env, docs=None,
-             HTML_HEADER = None, HTML_FOOTER = None,
-             TITLE = "Cross-reference of action points"):
-    if docs is None:
-        docs = env.Alias('all_docs')[0].sources
-    xrefs = [ doc for doc in docs if os.path.splitext(doc.name)[1] == ".xmli" ]
-    xref = env.Command("doc/html/xref.xml", xrefs,
-                       [ "echo '<?xml version=\"1.0\"?>' > $TARGET",
-                         "echo '<xref>' >> $TARGET",
-                         "cat $SOURCES >> $TARGET",
-                         "echo '</xref>' >>$TARGET" ])
-
-    # Lastly we create the html file
-    sources = [ xref, "%s/xrefhtml.xslt" % basedir ]
-    if HTML_HEADER : sources.append(HTML_HEADER)
-    if HTML_FOOTER : sources.append(HTML_FOOTER)
-
-    commands = []
-    if HTML_HEADER:
-        commands.append("sed" +
-                        " -e 's/\\$$title/$TITLE/g'" +
-                        " -e 's/\\$$projectname/Overview/g'" +
-                        " ${SOURCES[2]} > $TARGET")
-    commands.append("xsltproc" +
-                    " --stringparam title '$TITLE'" +
-                    " --stringparam types '$DOXY_XREF_TYPES'" +
-                    " ${SOURCES[1]} $SOURCE >> $TARGET")
-    if HTML_FOOTER:
-        commands.append(
-            "sed -e 's/\\$$title/$TITLE/g' -e 's/\\$$projectname/Overview/g' ${SOURCES[%d]} >> $TARGET"
-            % (HTML_HEADER and 3 or 2))
-
-    if env.get('DOXY_HTML_XSL'):
-        xslfile = env.File(env['DOXY_HTML_XSL'])
-        reltopdir = '../' * len(xref[0].dir.abspath[len(env.Dir('#').abspath)+1:].split('/'))
-        if reltopdir : reltopdir = reltopdir[:-1]
-        else         : reltopdir = '.'
-        commands.append(("xsltproc -o ${TARGET}.tmp" +
-                         " --nonet --html" +
-                         " --stringparam topdir %s" +
-                         " ${SOURCES[-1]} $TARGET 2>/dev/null")
-                        % reltopdir)
-        commands.append("mv ${TARGET}.tmp ${TARGET}")
-        sources.append(xslfile)
-        
-    xref = env.Command("doc/html/xref.html", sources, commands,
-                       TITLE = TITLE)
-
-    env.Alias('all_docs',xref)
-    return xref
+    # Useful aliases
+    env.Alias('all_docs', doc)
+    env.Clean('all_docs', doc)
+    env.Clean('all', doc)
 
+    return doc
 
 ## \brief Build library
 #